;Creado por: LUIS CARDENAS, neoluist@gmail.com, www.ingenieriafacil.com
;WEB: https://beacons.ai/neoluist
;CURSO AUTOLISP: https://www.udemy.com/course/autolisp-recursos-descargables-para-autocad/?referralCode=51433BE4745543474CB9
;05-06-2023
; Define una nueva función ASVIGA3
(defun c:ASVIGA3 ( / *error* op_file fname dcl fc fy b d Mu ø i ii iii a As r)

  ; Define la función de manejo de errores
  (defun *error* (msg)
    (and
      msg
      (not (wcmatch (strcase msg) "*CANCEL*,*EXIT*,*QUIT*,*BREAK*"))
      (princ (strcat "\nError: " msg))
    )
    ; si existe un archivo temporal, bórralo
    (if fname (vl-catch-all-apply 'vl-file-delete (list fname)))
    (princ)
  )

  ; Establecer variables para el nombre del archivo y para el archivo de salida
  ; Genera un nombre de archivo temporal con la función vl-filename-mktemp y abre ese archivo para escritura
  (setq
    fname (vl-filename-mktemp "ASVIGA" (getvar 'dwgprefix) ".dcl")
    op_file (open fname "w")
  )

  ; Escribe la definición del cuadro de diálogo en el archivo temporal
  (foreach x
    '("ASVIGA : dialog { label = \"ACERO POR FLEXIÓN - LUIS CARDENAS\";"
      ": column {"
      "  : row {"
      "    : text { label = \"Resistencia a la compresión del concreto f'c (kg/cm²):\"; alignment = left; width = 50; }"
      "    : edit_box { key = \"fc\"; alignment = left; width = 12; }"
      "  }"
      "  : row {"
      "    : text { label = \"Resistencia a la tracción del acero fy (kg/cm²):\"; alignment = left; width = 50; }"
      "    : edit_box { key = \"fy\"; alignment = left; width = 12; }"
      "  }"
      "  : row {"
      "    : text { label = \"Ancho de la viga b (cm):\"; alignment = left; width = 50; }"
      "    : edit_box { key = \"b\"; alignment = left; width = 12; }"
      "  }"
      "  : row {"
      "    : text { label = \"Altura de la viga d (cm):\"; alignment = left; width = 50; }"
      "    : edit_box { key = \"d\"; alignment = left; width = 12; }"
      "  }"
      "  : row {"
      "    : text { label = \"Carga máxima Mu (kg-cm):\"; alignment = left; width = 50; }"
      "    : edit_box { key = \"Mu\"; alignment = left; width = 12; }"
      "  }"
      "}"
      "ok_cancel;"
      "}"
    )
    (write-line x op_file)
  )

  ; Cierra el archivo
  (close op_file)

  ; Carga el cuadro de diálogo desde el archivo y lo muestra
  (if
    (and
      (> (setq dcl (load_dialog fname)) 0)
      (new_dialog "ASVIGA" dcl)
    )
    (progn
      ; Establecer los valores iniciales y las acciones para los cuadros de texto
      (setq fc 0 fy 0 b 0 d 0 Mu 0 ø 0.9)
      (action_tile "fc" "(setq fc (atof $value))")
      (action_tile "fy" "(setq fy (atof $value))")
      (action_tile "b" "(setq b (atof $value))")
      (action_tile "d" "(setq d (atof $value))")
      (action_tile "Mu" "(setq Mu (atof $value))")
      (setq r (start_dialog))
      (unload_dialog dcl)
    )
  )

  ; Si el usuario pulsó OK (r es 1), realiza los cálculos y muestra los resultados
  (if (= r 1)
    (progn
      (setq i (/ (* 0.85 ø fc b) 2))
      (setq ii (* -0.85 ø fc d b))
      (setq iii Mu)
      (setq a (/ (- (* ii -1) (sqrt (- (expt ii 2) (* 4 i iii)))) (* 2 i)))
      (setq As (/ (* 0.85 fc a b) fy))
      (alert (strcat "Área de acero requerida: " (rtos As 2 3) " cm²"))
    )
  )

  ; Llama a la función de manejo de errores con nil para limpiar después de que el script haya terminado
  (*error* nil)
  ; Imprime un nuevo línea al final para mantener la línea de comandos ordenada
  (princ)
)
(princ "El archivo AutoLISP ha sido cargado correctamente. \nCreado por: LUIS CARDENAS, neoluist@gmail.com, www.ingenieriafacil.com, https://beacons.ai/neoluist ")
;Creado por: LUIS CARDENAS, neoluist@gmail.com, www.ingenieriafacil.com
;WEB: https://beacons.ai/neoluist